Built-in Style Rules
There are several built-in style rules for each taskbar type (GC.Spread.Sheets.GanttSheet.TaskbarStyleRuleName):
durationOnly
durationOnlyMilestone
finishOnly
finishOnlyMilestone
manualMilestone
manualProgress
manualSummary
manualTask
milestone
progress
projectSummary
startOnly
startOnlyMilestone
summary
task
You can get the style rule and change its style properties like so:
Configurable Style Properties
startShape: GC.Spread.Sheets.GanttSheet.TaskbarEndShape
startType: GC.Spread.Sheets.GanttSheet.TaskbarEndType
startColor: string
endShape: GC.Spread.Sheets.GanttSheet.TaskbarEndShape
endType: GC.Spread.Sheets.GanttSheet.TaskbarEndType
endColor: string
middleShape: GC.Spread.Sheets.GanttSheet.TaskbarMiddleShape
middlePattern: GC.Spread.Sheets.GanttSheet.TaskbarFillPattern
middleColor: string
leftText: string
rightText: string
topText: string
bottomText: string
insideText: string
Text properties like leftText support the data field name and column formula:
Custom Style Rules
You can create a custom style rule based on the base style rule class (GC.Spread.Sheets.GanttSheet.TaskbarStyleRule):
Then add your custom style rule to the taskbar style rule collection (GC.Spread.Sheets.GanttSheet.TaskbarStyleRules):
You can update an existing custom style rule:
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
var myTable;
var ganttSheet;
window.onload = function() {
var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 0 });
initSpread(spread);
initSplitView(spread);
};
function initSpread(spread) {
spread.suspendPaint();
initDataSource(spread);
initGanttSheet(spread);
spread.resumePaint();
}
function initDataSource(spread) {
var tableName = "Gantt_Id";
var baseApiUrl = getBaseApiUrl();
var apiUrl = baseApiUrl + "/" + tableName;
var dataManager = spread.dataManager();
myTable = dataManager.addTable("myTable", {
batch: true,
remote: {
read: {
url: apiUrl
}
},
schema: {
hierarchy: {
type: "Parent",
column: "parentId"
},
columns: {
id: { isPrimaryKey: true },
taskNumber: { dataType: "rowOrder" }
}
}
});
}
function initGanttSheet(spread) {
ganttSheet = spread.addSheetTab(0, "GanttSheet", GC.Spread.Sheets.SheetType.ganttSheet);
var view = myTable.addView("ganttView", [
{ value: "taskNumber", caption: "NO.", width: 60 },
{ value: "mode", caption: "Mode", width: 65 },
{ value: "name", caption: "Task Name", width: 200 },
{ value: "duration", caption: "Duration", width: 90 },
{ value: "predecessors", caption: "Predecessors", width: 120, visible: false }
]);
view.fetch().then(function() {
ganttSheet.bindGanttView(view);
}).then(function() {
let taskRule = ganttSheet.project.taskStyleRules.getRule("task");
let taskStyle = taskRule.style.taskbarStyle;
taskStyle.middleColor = "#abd08f";
taskRule.style.taskbarStyle = taskStyle;
let summaryRule = ganttSheet.project.taskStyleRules.getRule("summary");
let summaryStyle = summaryRule.style.taskbarStyle;
summaryStyle.middleColor = "#00b050";
summaryStyle.startShape = "leftBracket";
summaryStyle.startColor = "#578335";
summaryStyle.endShape = "rightBracket";
summaryStyle.endColor = "#578335";
summaryRule.style.taskbarStyle = summaryStyle;
});
initSidePanel(ganttSheet);
}
function initSidePanel(ganttSheet) {
var setStyleItem = document.getElementById("set-style");
var styleRuleNameItem = document.getElementById("rule-name");
var startShapeItem = document.getElementById("start-shape");
var startTypeItem = document.getElementById("start-type");
var startColorItem = document.getElementById("start-color");
var middleShapeItem = document.getElementById("middle-shape");
var middlePatternItem = document.getElementById("middle-pattern");
var middleColorItem = document.getElementById("middle-color");
var endShapeItem = document.getElementById("end-shape");
var endTypeItem = document.getElementById("end-type");
var endColorItem = document.getElementById("end-color");
var leftTextItem = document.getElementById("left-text");
var rightTextItem = document.getElementById("right-text");
var topTextItem = document.getElementById("top-text");
var bottomTextItem = document.getElementById("bottom-text");
var insideTextItem = document.getElementById("inside-text");
var styleRuleName = styleRuleNameItem.value;
var targetStyle = ganttSheet.project.taskStyleRules.getRule(styleRuleName).style.taskbarStyle;
syncConfigFromStyle(targetStyle);
styleRuleNameItem.addEventListener("change", function() {
var styleRuleName = styleRuleNameItem.value;
var targetStyle = ganttSheet.project.taskStyleRules.getRule(styleRuleName).style.taskbarStyle;
syncConfigFromStyle(targetStyle);
});
setStyleItem.addEventListener("click", function() {
ganttSheet.suspendPaint();
var styleRuleName = styleRuleNameItem.value;
var targetStyleRule = ganttSheet.project.taskStyleRules.getRule(styleRuleName);
let ruleType = ["task", "milestone", "summary", "projectSummary", "manualTask", "manualMilestone", "durationOnly", "manualSummary", "startOnly", "finishOnly", "durationOnlyMilestone", "startOnlyMilestone", "finishOnlyMilestone", "progress", "manualProgress"];
let style = targetStyleRule.style;
style.taskbarStyle = getStyleFromConfig(style.taskbarStyle);
ganttSheet.project.taskStyleRules.setItemAt(ruleType.indexOf(styleRuleName), targetStyleRule);
ganttSheet.resumePaint();
});
function syncConfigFromStyle(targetStyle) {
startShapeItem.value = targetStyle.startShape;
startTypeItem.value = targetStyle.startType;
startColorItem.value = targetStyle.startColor ? targetStyle.startColor : "";
middleShapeItem.value = targetStyle.middleShape;
middlePatternItem.value = targetStyle.middlePattern;
middleColorItem.value = targetStyle.middleColor ? targetStyle.middleColor : "";
endShapeItem.value = targetStyle.endShape;
endTypeItem.value = targetStyle.endType;
endColorItem.value = targetStyle.endColor ? targetStyle.endColor : "";
leftTextItem.value = targetStyle.leftText || "";
rightTextItem.value = targetStyle.rightText || "";
topTextItem.value = targetStyle.topText || "";
bottomTextItem.value = targetStyle.bottomText || "";
insideTextItem.value = targetStyle.insideText || "";
}
function getStyleFromConfig(targetStyle) {
targetStyle.startShape = startShapeItem.value;
targetStyle.startType = startTypeItem.value;
targetStyle.startColor = startColorItem.value;
targetStyle.middleShape = middleShapeItem.value;
targetStyle.middlePattern = middlePatternItem.value;
targetStyle.middleColor = middleColorItem.value;
targetStyle.endShape = endShapeItem.value;
targetStyle.endType = endTypeItem.value;
targetStyle.endColor = endColorItem.value;
targetStyle.leftText = leftTextItem.value;
targetStyle.rightText = rightTextItem.value;
targetStyle.topText = topTextItem.value;
targetStyle.bottomText = bottomTextItem.value;
targetStyle.insideText = insideTextItem.value;
return targetStyle;
}
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
function initSplitView(spread) {
var host = document.getElementById("split-view");
var content = host.getElementsByClassName("split-content")[0];
var panel = host.getElementsByClassName("split-panel")[0];
new SplitView({
host: host,
content: content,
panel: panel,
refreshContent: function() {
spread.refresh();
}
});
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/spread/source/splitView/splitView.css">
<!-- Promise Polyfill for IE, https://www.npmjs.com/package/promise-polyfill -->
<script src="https://cdn.jsdelivr.net/npm/promise-polyfill@8/dist/polyfill.min.js"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-tablesheet/dist/gc.spread.sheets.tablesheet.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-ganttsheet/dist/gc.spread.sheets.ganttsheet.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/splitView/splitView.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div id="split-view" class="sample-tutorial">
<div id="ss" class="sample-spreadsheets split-content"></div>
<div class="options-container split-panel">
<div class="option-row option-title">
Config the taskbar style rules.
</div>
<div class="option-block">
<div class="option-row selection-box">
<label for="rule-name">Rule Name</label>
<select id="rule-name">
<option value="durationOnly">durationOnly</option>
<option value="durationOnlyMilestone">durationOnlyMilestone</option>
<option value="finishOnly">finishOnly</option>
<option value="finishOnlyMilestone">finishOnlyMilestone</option>
<option value="manualMilestone">manualMilestone</option>
<option value="manualProgress">manualProgress</option>
<option value="manualSummary">manualSummary</option>
<option value="manualTask">manualTask</option>
<option value="milestone">milestone</option>
<option value="progress">progress</option>
<option value="projectSummary">projectSummary</option>
<option value="startOnly">startOnly</option>
<option value="startOnlyMilestone">startOnlyMilestone</option>
<option value="summary">summary</option>
<option value="task" selected>task</option>
</select>
</div>
<div class="option-row">
<input type="button" id="set-style" class="option-button" value="Set Taskbar Styles">
</div>
</div>
<div class="option-block">
<div class="option-row option-title">
Config the taskbar style.
</div>
<div class="option-block">
<div class="option-row option-title">
Start
</div>
<div class="option-row selection-box">
<label for="start-shape">Shape</label>
<select id="start-shape">
<option value="" selected></option>
<option value="arrowDown">arrowDown</option>
<option value="arrowUp">arrowUp</option>
<option value="caretDownTop">caretDownTop</option>
<option value="caretUpBottom">caretUpBottom</option>
<option value="circle">circle</option>
<option value="circleArrowDown">circleArrowDown</option>
<option value="circleArrowUp">circleArrowUp</option>
<option value="circleDiamond">circleDiamond</option>
<option value="circleTriangleDown">circleTriangleDown</option>
<option value="circleTriangleUp">circleTriangleUp</option>
<option value="diamond">diamond</option>
<option value="houseDown">houseDown</option>
<option value="houseUp">houseUp</option>
<option value="leftBracket">leftBracket</option>
<option value="leftFade">leftFade</option>
<option value="lineShape">lineShape</option>
<option value="rightBracket">rightBracket</option>
<option value="rightFade">rightFade</option>
<option value="square">square</option>
<option value="star">star</option>
<option value="triangleDown">triangleDown</option>
<option value="triangleLeft">triangleLeft</option>
<option value="triangleRight">triangleRight</option>
<option value="triangleUp">triangleUp</option>
</select>
</div>
<div class="option-row selection-box">
<label for="start-type">Type</label>
<select id="start-type">
<option value="" selected></option>
<option value="solid">solid</option>
<option value="dashed">dashed</option>
<option value="framed">framed</option>
</select>
</div>
<div class="option-row input-box">
<label for="start-color">Color</label>
<input type="text" id="start-color" />
<div class="option-info valid">* valid value: color string</div>
</div>
</div>
<div class="option-block">
<div class="option-row option-title">
Middle
</div>
<div class="option-row selection-box">
<label for="middle-shape">Shape</label>
<select id="middle-shape">
<option value="" selected></option>
<option value="lineBottom">lineBottom</option>
<option value="lineMiddle">lineMiddle</option>
<option value="lineTop">lineTop</option>
<option value="rectangleBar">rectangleBar</option>
<option value="rectangleBottom">rectangleBottom</option>
<option value="rectangleMiddle">rectangleMiddle</option>
<option value="rectangleTop">rectangleTop</option>
</select>
</div>
<div class="option-row selection-box">
<label for="middle-pattern">Fill Pattern</label>
<select id="middle-pattern">
<option value="" selected></option>
<option value="darkFill">darkFill</option>
<option value="dashedBorder">dashedBorder</option>
<option value="diagonalCross">diagonalCross</option>
<option value="diagonalLeft">diagonalLeft</option>
<option value="diagonalRight">diagonalRight</option>
<option value="hollow">hollow</option>
<option value="lightFill">lightFill</option>
<option value="lineCross">lineCross</option>
<option value="lineHorizontal">lineHorizontal</option>
<option value="lineVertical">lineVertical</option>
<option value="mediumFill">mediumFill</option>
<option value="solidFill">solidFill</option>
</select>
</div>
<div class="option-row input-box">
<label for="middle-color">Color</label>
<input type="text" id="middle-color" />
<div class="option-info valid">* valid value: color string</div>
</div>
</div>
<div class="option-block">
<div class="option-row option-title">
End
</div>
<div class="option-row selection-box">
<label for="end-shape">Shape</label>
<select id="end-shape">
<option value="" selected></option>
<option value="arrowDown">arrowDown</option>
<option value="arrowUp">arrowUp</option>
<option value="caretDownTop">caretDownTop</option>
<option value="caretUpBottom">caretUpBottom</option>
<option value="circle">circle</option>
<option value="circleArrowDown">circleArrowDown</option>
<option value="circleArrowUp">circleArrowUp</option>
<option value="circleDiamond">circleDiamond</option>
<option value="circleTriangleDown">circleTriangleDown</option>
<option value="circleTriangleUp">circleTriangleUp</option>
<option value="diamond">diamond</option>
<option value="houseDown">houseDown</option>
<option value="houseUp">houseUp</option>
<option value="leftBracket">leftBracket</option>
<option value="leftFade">leftFade</option>
<option value="lineShape">lineShape</option>
<option value="rightBracket">rightBracket</option>
<option value="rightFade">rightFade</option>
<option value="square">square</option>
<option value="star">star</option>
<option value="triangleDown">triangleDown</option>
<option value="triangleLeft">triangleLeft</option>
<option value="triangleRight">triangleRight</option>
<option value="triangleUp">triangleUp</option>
</select>
</div>
<div class="option-row selection-box">
<label for="end-type">Type</label>
<select id="end-type">
<option value="" selected></option>
<option value="solid">solid</option>
<option value="dashed">dashed</option>
<option value="framed">framed</option>
</select>
</div>
<div class="option-row input-box">
<label for="end-color">Color</label>
<input type="text" id="end-color" />
<div class="option-info valid">* valid value: color string</div>
</div>
</div>
</div>
<div class="option-block">
<div class="option-row option-title">
Config the taskbar text.
</div>
<div class="option-row input-box">
<label for="left-text">Left Text</label>
<input type="text" id="left-text" />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
<div class="option-row input-box">
<label for="right-text">Right Text</label>
<input type="text" id="right-text" />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
<div class="option-row input-box">
<label for="top-text">Top Text</label>
<input type="text" id="top-text" />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
<div class="option-row input-box">
<label for="bottom-text">Bottom Text</label>
<input type="text" id="bottom-text" />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
<div class="option-row input-box">
<label for="inside-text">Inside Text</label>
<input type="text" id="inside-text" />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
</div>
</div>
</div>
</html>
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
box-shadow: inset 0px 0 4px 0 rgba(0,0,0,0.4);
}
.option-block {
background: #fff;
padding: 8px;
margin: 12px 0;
border-radius: 4px;
border: 1px dashed #82bc00;
box-shadow: 0px 0 6px 0 rgba(0,0,0,0.1);
}
.option-block.toggle {
border: 1px dotted #f7a711;
}
.option-row {
font-size: 14px;
box-sizing: border-box;
padding: 4px 0;
}
.option-title {
font-weight: bold;
color: #656565;
}
.option-info {
font-size: 12px;
color: #919191;
margin-top: 6px;
font-weight: normal;
}
.option-info.valid {
color: #82bc00;
}
.option-info.toggle {
color: #f7a711;
}
.option-button {
width: 100%;
padding: 0;
line-height: 20px;
background: #82bc00;
color: #fff;
transition: 0.3s;
cursor: pointer;
outline: none;
border-radius: 4px;
box-sizing: border-box;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
border: none;
}
.option-button:hover {
background: #82bc00;
color: #fff;
box-shadow: 0 3px 8px 0 rgba(0,0,0,0.4);
}
.option-checkbox {
background: #fff;
border: 1px dashed #f7a711;
color: #f7a711;
padding: 2px 4px;
transition: 0.3s;
box-sizing: border-box;
cursor: pointer;
}
.option-checkbox.active {
color: #fff;
background: #f7a711;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
border-radius: 4px;
}
.selection-box {
position: relative;
}
.selection-box > select {
text-align: left;
width: 100%;
height: 20px;
padding: 0;
line-height: 20px;
background: transparent;
border: none;
border-bottom: 2px solid #656565;
color: #656565;
transition: 0.3s;
cursor: pointer;
outline: none;
box-sizing: border-box;
}
.selection-box > select > option {
background: white;
}
.selection-box > select:focus {
border-bottom: 2px solid #82bc00;
color: #82bc00;
box-shadow: 0 2px 6px 0 rgba(0,0,0,0.3);
}
.selection-box > label {
position: absolute;
cursor: pointer;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
right: 0;
top: 6px;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
}
.input-box {
position: relative;
}
.input-box > input[type=text] {
width: 100%;
background: transparent;
border: none;
color: #656565;
border-bottom: 2px solid #656565;
outline: none;
box-sizing: border-box;
transition: 0.3s;
}
.input-box > input[type=text]:focus {
color: #82bc00;
border-bottom: 2px solid #82bc00;
}
.input-box > label {
cursor: pointer;
position: absolute;
right: 0;
top: 5px;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
}

Built-in Style Rules
There are several built-in style rules for each taskbar type (GC.Spread.Sheets.GanttSheet.TaskbarStyleRuleName):
durationOnly
durationOnlyMilestone
finishOnly
finishOnlyMilestone
manualMilestone
manualProgress
manualSummary
manualTask
milestone
progress
projectSummary
startOnly
startOnlyMilestone
summary
task
You can get the style rule and change its style properties like so:
Configurable Style Properties
startShape: GC.Spread.Sheets.GanttSheet.TaskbarEndShape
startType: GC.Spread.Sheets.GanttSheet.TaskbarEndType
startColor: string
endShape: GC.Spread.Sheets.GanttSheet.TaskbarEndShape
endType: GC.Spread.Sheets.GanttSheet.TaskbarEndType
endColor: string
middleShape: GC.Spread.Sheets.GanttSheet.TaskbarMiddleShape
middlePattern: GC.Spread.Sheets.GanttSheet.TaskbarFillPattern
middleColor: string
leftText: string
rightText: string
topText: string
bottomText: string
insideText: string
Text properties like leftText support the data field name and column formula:
Custom Style Rules
You can create a custom style rule based on the base style rule class (GC.Spread.Sheets.GanttSheet.TaskbarStyleRule):
Then add your custom style rule to the taskbar style rule collection (GC.Spread.Sheets.GanttSheet.TaskbarStyleRules):
You can update an existing custom style rule:
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import { Component, NgModule, enableProdMode } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";
import { FormsModule } from "@angular/forms";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { SpreadSheetsModule } from "@mescius/spread-sheets-angular";
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-ganttsheet";
import './styles.css';
declare var SplitView: any;
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
ganttSheet: GC.Spread.Sheets.GanttSheet;
ruleName = "task";
startShape = "";
startType = "";
startColor = "";
middleShape = "rectangleBar";
middlePattern = "diagonalLeft";
middleColor = "#8abbed";
endShape = "";
endType = "";
endColor = "";
leftText = "";
rightText = "";
topText = "";
bottomText = "";
insideText = "";
hostStyle = {
width: '100%',
height: '100%'
};
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
spread.suspendPaint();
spread.clearSheets();
this.initDataSource(spread);
this.initGanttSheet(spread);
spread.resumePaint();
initSplitView(spread);
}
initDataSource(spread) {
var tableName = "Gantt_Id";
var baseApiUrl = getBaseApiUrl();
var apiUrl = baseApiUrl + "/" + tableName;
var dataManager = spread.dataManager();
var myTable = dataManager.addTable("myTable", {
batch: true,
remote: {
read: {
url: apiUrl
}
},
schema: {
hierarchy: {
type: "Parent",
column: "parentId"
},
columns: {
id: { isPrimaryKey: true },
taskNumber: { dataType: "rowOrder" }
}
}
});
this.myTable = myTable;
}
initGanttSheet(spread) {
var ganttSheet = spread.addSheetTab(0, "GanttSheet", GC.Spread.Sheets.SheetType.ganttSheet);
var view = this.myTable.addView("ganttView", [
{ value: "taskNumber", caption: "NO.", width: 60 },
{ value: "mode", caption: "Mode", width: 65 },
{ value: "name", caption: "Task Name", width: 200 },
{ value: "duration", caption: "Duration", width: 90 },
{ value: "predecessors", caption: "Predecessors", width: 120, visible: false }
]);
view.fetch().then(function() {
ganttSheet.bindGanttView(view);
}).then(function() {
let taskRule = ganttSheet.project.taskStyleRules.getRule("task");
let taskStyle = taskRule.style.taskbarStyle;
taskStyle.middleColor = "#abd08f";
taskRule.style.taskbarStyle = taskStyle;
let summaryRule = ganttSheet.project.taskStyleRules.getRule("summary");
let summaryStyle = summaryRule.style.taskbarStyle;
summaryStyle.middleColor = "#00b050";
summaryStyle.startShape = "leftBracket";
summaryStyle.startColor = "#578335";
summaryStyle.endShape = "rightBracket";
summaryStyle.endColor = "#578335";
summaryRule.style.taskbarStyle = summaryStyle;
});
this.ganttSheet = ganttSheet;
}
syncConfigFromStyle() {
var ganttSheet = this.ganttSheet;
var styleRuleName = this.ruleName;
var targetStyle = ganttSheet.project.taskStyleRules.getRule(styleRuleName).style.taskbarStyle;
if (targetStyle) {
this.startShape = targetStyle.startShape;
this.startType = targetStyle.startType;
this.startColor = targetStyle.startColor ? targetStyle.startColor : "";
this.middleShape = targetStyle.middleShape;
this.middlePattern = targetStyle.middlePattern;
this.middleColor = targetStyle.middleColor ? targetStyle.middleColor : "";
this.endShape = targetStyle.endShape;
this.endType = targetStyle.endType;
this.endColor = targetStyle.endColor ? targetStyle.endColor : "";
this.leftText = targetStyle.leftText || "";
this.rightText = targetStyle.rightText || "";
this.topText = targetStyle.topText || "";
this.bottomText = targetStyle.bottomText || "";
this.insideText = targetStyle.insideText || "";
}
}
getStyleFromConfig(targetStyle) {
if (!targetStyle) {
targetStyle = {};
}
targetStyle.startShape = this.startShape;
targetStyle.startType = this.startType;
targetStyle.startColor = this.startColor;
targetStyle.middleShape = this.middleShape;
targetStyle.middlePattern = this.middlePattern;
targetStyle.middleColor = this.middleColor;
targetStyle.endShape = this.endShape;
targetStyle.endType = this.endType;
targetStyle.endColor = this.endColor;
targetStyle.leftText = this.leftText;
targetStyle.rightText = this.rightText;
targetStyle.topText = this.topText;
targetStyle.bottomText = this.bottomText;
targetStyle.insideText = this.insideText;
return targetStyle;
}
setStyle() {
var ganttSheet = this.ganttSheet;
ganttSheet.suspendPaint();
var styleRuleName = this.ruleName;
var targetStyleRule = ganttSheet.project.taskStyleRules.getRule(styleRuleName);
let ruleType = ["task", "milestone", "summary", "projectSummary", "manualTask", "manualMilestone", "durationOnly", "manualSummary", "startOnly", "finishOnly", "durationOnlyMilestone", "startOnlyMilestone", "finishOnlyMilestone", "progress", "manualProgress"];
let style = targetStyleRule.style;
style.taskbarStyle = this.getStyleFromConfig(style.taskbarStyle);
ganttSheet.project.taskStyleRules.setItemAt(ruleType.indexOf(styleRuleName), targetStyleRule);
ganttSheet.resumePaint()
}
}
function initSplitView(spread) {
var host = document.getElementById("split-view");
var content = host.getElementsByClassName("split-content")[0];
var panel = host.getElementsByClassName("split-panel")[0];
new SplitView({
host: host,
content: content,
panel: panel,
refreshContent: function() {
spread.refresh();
}
});
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/spread/source/splitView/splitView.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<!-- plugins -->
<script src="$DEMOROOT$/spread/source/splitView/SplitView.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div id="split-view" class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets split-content" [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)"></gc-spread-sheets>
<div class="options-container split-panel">
<div class="option-row option-title">
Config the taskbar style rules.
</div>
<div class="option-block">
<div class="option-row selection-box">
<label for="rule-name">Rule Name</label>
<select id="rule-name" [(ngModel)]="ruleName" (change)="syncConfigFromStyle()">
<option value="durationOnly">durationOnly</option>
<option value="durationOnlyMilestone">durationOnlyMilestone</option>
<option value="finishOnly">finishOnly</option>
<option value="finishOnlyMilestone">finishOnlyMilestone</option>
<option value="manualMilestone">manualMilestone</option>
<option value="manualProgress">manualProgress</option>
<option value="manualSummary">manualSummary</option>
<option value="manualTask">manualTask</option>
<option value="milestone">milestone</option>
<option value="progress">progress</option>
<option value="projectSummary">projectSummary</option>
<option value="startOnly">startOnly</option>
<option value="startOnlyMilestone">startOnlyMilestone</option>
<option value="summary">summary</option>
<option value="task" selected>task</option>
</select>
</div>
<div class="option-row">
<input type="button" id="set-style" class="option-button" value="Set Taskbar Styles" (click)="setStyle()" >
</div>
</div>
<div class="option-block">
<div class="option-row option-title">
Config the taskbar style.
</div>
<div class="option-block">
<div class="option-row option-title">
Start
</div>
<div class="option-row selection-box">
<label for="start-shape">Shape</label>
<select id="start-shape" [(ngModel)]="startShape">
<option value=""></option>
<option value="arrowDown">arrowDown</option>
<option value="arrowUp">arrowUp</option>
<option value="caretDownTop">caretDownTop</option>
<option value="caretUpBottom">caretUpBottom</option>
<option value="circle">circle</option>
<option value="circleArrowDown">circleArrowDown</option>
<option value="circleArrowUp">circleArrowUp</option>
<option value="circleDiamond">circleDiamond</option>
<option value="circleTriangleDown">circleTriangleDown</option>
<option value="circleTriangleUp">circleTriangleUp</option>
<option value="diamond">diamond</option>
<option value="houseDown">houseDown</option>
<option value="houseUp">houseUp</option>
<option value="leftBracket">leftBracket</option>
<option value="leftFade">leftFade</option>
<option value="lineShape" selected>lineShape</option>
<option value="rightBracket">rightBracket</option>
<option value="rightFade">rightFade</option>
<option value="square">square</option>
<option value="star">star</option>
<option value="triangleDown">triangleDown</option>
<option value="triangleLeft">triangleLeft</option>
<option value="triangleRight">triangleRight</option>
<option value="triangleUp">triangleUp</option>
</select>
</div>
<div class="option-row selection-box">
<label for="start-type">Type</label>
<select id="start-type" [(ngModel)]="startType">
<option value=""></option>
<option value="solid" selected>solid</option>
<option value="dashed">dashed</option>
<option value="framed">framed</option>
</select>
</div>
<div class="option-row input-box">
<label for="start-color">Color</label>
<input type="text" id="start-color" [(ngModel)]="startColor" />
<div class="option-info valid">* valid value: color string</div>
</div>
</div>
<div class="option-block">
<div class="option-row option-title">
Middle
</div>
<div class="option-row selection-box">
<label for="middle-shape">Shape</label>
<select id="middle-shape" [(ngModel)]="middleShape">
<option value=""></option>
<option value="lineBottom">lineBottom</option>
<option value="lineMiddle">lineMiddle</option>
<option value="lineTop">lineTop</option>
<option value="rectangleBar" selected>rectangleBar</option>
<option value="rectangleBottom">rectangleBottom</option>
<option value="rectangleMiddle">rectangleMiddle</option>
<option value="rectangleTop">rectangleTop</option>
</select>
</div>
<div class="option-row selection-box">
<label for="middle-pattern">Fill Pattern</label>
<select id="middle-pattern" [(ngModel)]="middlePattern">
<option value=""></option>
<option value="darkFill">darkFill</option>
<option value="dashedBorder">dashedBorder</option>
<option value="diagonalCross">diagonalCross</option>
<option value="diagonalLeft" selected>diagonalLeft</option>
<option value="diagonalRight">diagonalRight</option>
<option value="hollow">hollow</option>
<option value="lightFill">lightFill</option>
<option value="lineCross">lineCross</option>
<option value="lineHorizontal">lineHorizontal</option>
<option value="lineVertical">lineVertical</option>
<option value="mediumFill">mediumFill</option>
<option value="solidFill">solidFill</option>
</select>
</div>
<div class="option-row input-box">
<label for="middle-color">Color</label>
<input type="text" id="middle-color" [(ngModel)]="middleColor" />
<div class="option-info valid">* valid value: color string</div>
</div>
</div>
<div class="option-block">
<div class="option-row option-title">
End
</div>
<div class="option-row selection-box">
<label for="end-shape">Shape</label>
<select id="end-shape" [(ngModel)]="endShape">
<option value=""></option>
<option value="arrowDown">arrowDown</option>
<option value="arrowUp">arrowUp</option>
<option value="caretDownTop">caretDownTop</option>
<option value="caretUpBottom">caretUpBottom</option>
<option value="circle">circle</option>
<option value="circleArrowDown">circleArrowDown</option>
<option value="circleArrowUp">circleArrowUp</option>
<option value="circleDiamond">circleDiamond</option>
<option value="circleTriangleDown">circleTriangleDown</option>
<option value="circleTriangleUp">circleTriangleUp</option>
<option value="diamond">diamond</option>
<option value="houseDown">houseDown</option>
<option value="houseUp">houseUp</option>
<option value="leftBracket">leftBracket</option>
<option value="leftFade">leftFade</option>
<option value="lineShape" selected>lineShape</option>
<option value="rightBracket">rightBracket</option>
<option value="rightFade">rightFade</option>
<option value="square">square</option>
<option value="star">star</option>
<option value="triangleDown">triangleDown</option>
<option value="triangleLeft">triangleLeft</option>
<option value="triangleRight">triangleRight</option>
<option value="triangleUp">triangleUp</option>
</select>
</div>
<div class="option-row selection-box">
<label for="end-type">Type</label>
<select id="end-type" [(ngModel)]="endType">
<option value=""></option>
<option value="solid" selected>solid</option>
<option value="dashed">dashed</option>
<option value="framed">framed</option>
</select>
</div>
<div class="option-row input-box">
<label for="end-color">Color</label>
<input type="text" id="end-color" [(ngModel)]="endColor" />
<div class="option-info valid">* valid value: color string</div>
</div>
</div>
</div>
<div class="option-block">
<div class="option-row option-title">
Config the taskbar text.
</div>
<div class="option-row input-box">
<label for="left-text">Left Text</label>
<input type="text" id="left-text" [(ngModel)]="leftText" />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
<div class="option-row input-box">
<label for="right-text">Right Text</label>
<input type="text" id="right-text" [(ngModel)]="rightText" />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
<div class="option-row input-box">
<label for="top-text">Top Text</label>
<input type="text" id="top-text" [(ngModel)]="topText" />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
<div class="option-row input-box">
<label for="bottom-text">Bottom Text</label>
<input type="text" id="bottom-text" [(ngModel)]="bottomText" />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
<div class="option-row input-box">
<label for="inside-text">Inside Text</label>
<input type="text" id="inside-text" [(ngModel)]="insideText" />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
</div>
</div>
</div>
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
box-shadow: inset 0px 0 4px 0 rgba(0,0,0,0.4);
}
.option-block {
background: #fff;
padding: 8px;
margin: 12px 0;
border-radius: 4px;
border: 1px dashed #82bc00;
box-shadow: 0px 0 6px 0 rgba(0,0,0,0.1);
}
.option-block.toggle {
border: 1px dotted #f7a711;
}
.option-row {
font-size: 14px;
box-sizing: border-box;
padding: 4px 0;
}
.option-title {
font-weight: bold;
color: #656565;
}
.option-info {
font-size: 12px;
color: #919191;
margin-top: 6px;
font-weight: normal;
}
.option-info.valid {
color: #82bc00;
}
.option-info.toggle {
color: #f7a711;
}
.option-button {
width: 100%;
padding: 0;
line-height: 20px;
background: #82bc00;
color: #fff;
transition: 0.3s;
cursor: pointer;
outline: none;
border-radius: 4px;
box-sizing: border-box;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
border: none;
}
.option-button:hover {
background: #82bc00;
color: #fff;
box-shadow: 0 3px 8px 0 rgba(0,0,0,0.4);
}
.option-checkbox {
background: #fff;
border: 1px dashed #f7a711;
color: #f7a711;
padding: 2px 4px;
transition: 0.3s;
box-sizing: border-box;
cursor: pointer;
}
.option-checkbox.active {
color: #fff;
background: #f7a711;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
border-radius: 4px;
}
.selection-box {
position: relative;
}
.selection-box > select {
text-align: left;
width: 100%;
height: 20px;
padding: 0;
line-height: 20px;
background: transparent;
border: none;
border-bottom: 2px solid #656565;
color: #656565;
transition: 0.3s;
cursor: pointer;
outline: none;
box-sizing: border-box;
}
.selection-box > select > option {
background: white;
}
.selection-box > select:focus {
border-bottom: 2px solid #82bc00;
color: #82bc00;
box-shadow: 0 2px 6px 0 rgba(0,0,0,0.3);
}
.selection-box > label {
position: absolute;
cursor: pointer;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
right: 0;
top: 6px;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
}
.input-box {
position: relative;
}
.input-box > input[type=text] {
width: 100%;
background: transparent;
border: none;
color: #656565;
border-bottom: 2px solid #656565;
outline: none;
box-sizing: border-box;
transition: 0.3s;
}
.input-box > input[type=text]:focus {
color: #82bc00;
border-bottom: 2px solid #82bc00;
}
.input-box > label {
cursor: pointer;
position: absolute;
right: 0;
top: 5px;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-ganttsheet': 'npm:@mescius/spread-sheets-ganttsheet/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

Built-in Style Rules
There are several built-in style rules for each taskbar type (GC.Spread.Sheets.GanttSheet.TaskbarStyleRuleName):
durationOnly
durationOnlyMilestone
finishOnly
finishOnlyMilestone
manualMilestone
manualProgress
manualSummary
manualTask
milestone
progress
projectSummary
startOnly
startOnlyMilestone
summary
task
You can get the style rule and change its style properties like so:
Configurable Style Properties
startShape: GC.Spread.Sheets.GanttSheet.TaskbarEndShape
startType: GC.Spread.Sheets.GanttSheet.TaskbarEndType
startColor: string
endShape: GC.Spread.Sheets.GanttSheet.TaskbarEndShape
endType: GC.Spread.Sheets.GanttSheet.TaskbarEndType
endColor: string
middleShape: GC.Spread.Sheets.GanttSheet.TaskbarMiddleShape
middlePattern: GC.Spread.Sheets.GanttSheet.TaskbarFillPattern
middleColor: string
leftText: string
rightText: string
topText: string
bottomText: string
insideText: string
Text properties like leftText support the data field name and column formula:
Custom Style Rules
You can create a custom style rule based on the base style rule class (GC.Spread.Sheets.GanttSheet.TaskbarStyleRule):
Then add your custom style rule to the taskbar style rule collection (GC.Spread.Sheets.GanttSheet.TaskbarStyleRules):
You can update an existing custom style rule:
<template>
<div id="split-view" class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets split-content" @workbookInitialized="initSpread">
</gc-spread-sheets>
<div class="options-container split-panel">
<div class="option-row option-title">
Config the taskbar style rules.
</div>
<div class="option-block">
<div class="option-row selection-box">
<label for="rule-name">Rule Name</label>
<select id="rule-name" v-model="ruleName" @change="syncConfigFromStyle()">
<option value="durationOnly">durationOnly</option>
<option value="durationOnlyMilestone">durationOnlyMilestone</option>
<option value="finishOnly">finishOnly</option>
<option value="finishOnlyMilestone">finishOnlyMilestone</option>
<option value="manualMilestone">manualMilestone</option>
<option value="manualProgress">manualProgress</option>
<option value="manualSummary">manualSummary</option>
<option value="manualTask">manualTask</option>
<option value="milestone">milestone</option>
<option value="progress">progress</option>
<option value="projectSummary">projectSummary</option>
<option value="startOnly">startOnly</option>
<option value="startOnlyMilestone">startOnlyMilestone</option>
<option value="summary">summary</option>
<option value="task" selected>task</option>
</select>
</div>
<div class="option-row">
<input type="button" id="set-style" class="option-button" value="Set Taskbar Styles"
@click="setStyle()">
</div>
</div>
<div class="option-block">
<div class="option-row option-title">
Config the taskbar style.
</div>
<div class="option-block">
<div class="option-row option-title">
Start
</div>
<div class="option-row selection-box">
<label for="start-shape">Shape</label>
<select id="start-shape" v-model="startShape">
<option value=""></option>
<option value="arrowDown">arrowDown</option>
<option value="arrowUp">arrowUp</option>
<option value="caretDownTop">caretDownTop</option>
<option value="caretUpBottom">caretUpBottom</option>
<option value="circle">circle</option>
<option value="circleArrowDown">circleArrowDown</option>
<option value="circleArrowUp">circleArrowUp</option>
<option value="circleDiamond">circleDiamond</option>
<option value="circleTriangleDown">circleTriangleDown</option>
<option value="circleTriangleUp">circleTriangleUp</option>
<option value="diamond">diamond</option>
<option value="houseDown">houseDown</option>
<option value="houseUp">houseUp</option>
<option value="leftBracket">leftBracket</option>
<option value="leftFade">leftFade</option>
<option value="lineShape" selected>lineShape</option>
<option value="rightBracket">rightBracket</option>
<option value="rightFade">rightFade</option>
<option value="square">square</option>
<option value="star">star</option>
<option value="triangleDown">triangleDown</option>
<option value="triangleLeft">triangleLeft</option>
<option value="triangleRight">triangleRight</option>
<option value="triangleUp">triangleUp</option>
</select>
</div>
<div class="option-row selection-box">
<label for="start-type">Type</label>
<select id="start-type" v-model="startType">
<option value=""></option>
<option value="solid" selected>solid</option>
<option value="dashed">dashed</option>
<option value="framed">framed</option>
</select>
</div>
<div class="option-row input-box">
<label for="start-color">Color</label>
<input type="text" id="start-color" v-model="startColor" />
<div class="option-info valid">* valid value: color string</div>
</div>
</div>
<div class="option-block">
<div class="option-row option-title">
Middle
</div>
<div class="option-row selection-box">
<label for="middle-shape">Shape</label>
<select id="middle-shape" v-model="middleShape">
<option value=""></option>
<option value="lineBottom">lineBottom</option>
<option value="lineMiddle">lineMiddle</option>
<option value="lineTop">lineTop</option>
<option value="rectangleBar" selected>rectangleBar</option>
<option value="rectangleBottom">rectangleBottom</option>
<option value="rectangleMiddle">rectangleMiddle</option>
<option value="rectangleTop">rectangleTop</option>
</select>
</div>
<div class="option-row selection-box">
<label for="middle-pattern">Fill Pattern</label>
<select id="middle-pattern" v-model="middlePattern">
<option value=""></option>
<option value="darkFill">darkFill</option>
<option value="dashedBorder">dashedBorder</option>
<option value="diagonalCross">diagonalCross</option>
<option value="diagonalLeft" selected>diagonalLeft</option>
<option value="diagonalRight">diagonalRight</option>
<option value="hollow">hollow</option>
<option value="lightFill">lightFill</option>
<option value="lineCross">lineCross</option>
<option value="lineHorizontal">lineHorizontal</option>
<option value="lineVertical">lineVertical</option>
<option value="mediumFill">mediumFill</option>
<option value="solidFill">solidFill</option>
</select>
</div>
<div class="option-row input-box">
<label for="middle-color">Color</label>
<input type="text" id="middle-color" v-model="middleColor" />
<div class="option-info valid">* valid value: color string</div>
</div>
</div>
<div class="option-block">
<div class="option-row option-title">
End
</div>
<div class="option-row selection-box">
<label for="end-shape">Shape</label>
<select id="end-shape" v-model="endShape">
<option value=""></option>
<option value="arrowDown">arrowDown</option>
<option value="arrowUp">arrowUp</option>
<option value="caretDownTop">caretDownTop</option>
<option value="caretUpBottom">caretUpBottom</option>
<option value="circle">circle</option>
<option value="circleArrowDown">circleArrowDown</option>
<option value="circleArrowUp">circleArrowUp</option>
<option value="circleDiamond">circleDiamond</option>
<option value="circleTriangleDown">circleTriangleDown</option>
<option value="circleTriangleUp">circleTriangleUp</option>
<option value="diamond">diamond</option>
<option value="houseDown">houseDown</option>
<option value="houseUp">houseUp</option>
<option value="leftBracket">leftBracket</option>
<option value="leftFade">leftFade</option>
<option value="lineShape" selected>lineShape</option>
<option value="rightBracket">rightBracket</option>
<option value="rightFade">rightFade</option>
<option value="square">square</option>
<option value="star">star</option>
<option value="triangleDown">triangleDown</option>
<option value="triangleLeft">triangleLeft</option>
<option value="triangleRight">triangleRight</option>
<option value="triangleUp">triangleUp</option>
</select>
</div>
<div class="option-row selection-box">
<label for="end-type">Type</label>
<select id="end-type" v-model="endType">
<option value=""></option>
<option value="solid" selected>solid</option>
<option value="dashed">dashed</option>
<option value="framed">framed</option>
</select>
</div>
<div class="option-row input-box">
<label for="end-color">Color</label>
<input type="text" id="end-color" v-model="endColor" />
<div class="option-info valid">* valid value: color string</div>
</div>
</div>
</div>
<div class="option-block">
<div class="option-row option-title">
Config the taskbar text.
</div>
<div class="option-row input-box">
<label for="left-text">Left Text</label>
<input type="text" id="left-text" v-model="leftText" />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
<div class="option-row input-box">
<label for="right-text">Right Text</label>
<input type="text" id="right-text" v-model="rightText" />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
<div class="option-row input-box">
<label for="top-text">Top Text</label>
<input type="text" id="top-text" v-model="topText" />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
<div class="option-row input-box">
<label for="bottom-text">Bottom Text</label>
<input type="text" id="bottom-text" v-model="bottomText" />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
<div class="option-row input-box">
<label for="inside-text">Inside Text</label>
<input type="text" id="inside-text" v-model="insideText" />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
</div>
</div>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import { ref } from "vue";
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-ganttsheet";
import "@mescius/spread-sheets-vue";
const spreadRef = ref(null);
let myTable = null;
let ganttSheet = null;
let spread = null;
const ruleName = ref("task");
const startShape = ref("");
const startType = ref("");
const startColor = ref("");
const middleShape = ref("rectangleBar");
const middlePattern = ref("diagonalLeft");
const middleColor = ref("#8abbed");
const endShape = ref("");
const endType = ref("");
const endColor = ref("");
const leftText = ref("");
const rightText = ref("");
const topText = ref("");
const bottomText = ref("");
const insideText = ref("");
function initSpread(spread) {
spreadRef.value = spread;
spread.suspendPaint();
spread.clearSheets();
initDataSource(spread);
initGanttSheet(spread);
spread.resumePaint();
initSplitView(spread);
};
function initDataSource(spread) {
var tableName = "Gantt_Id";
var baseApiUrl = getBaseApiUrl();
var apiUrl = baseApiUrl + "/" + tableName;
var dataManager = spread.dataManager();
myTable = dataManager.addTable("myTable", {
batch: true,
remote: {
read: {
url: apiUrl
}
},
schema: {
hierarchy: {
type: "Parent",
column: "parentId"
},
columns: {
id: { isPrimaryKey: true },
taskNumber: { dataType: "rowOrder" }
}
}
});
};
function initGanttSheet(spread) {
ganttSheet = spread.addSheetTab(0, "GanttSheet", GC.Spread.Sheets.SheetType.ganttSheet);
var view = myTable.addView("ganttView", [
{ value: "taskNumber", caption: "NO.", width: 60 },
{ value: "mode", caption: "Mode", width: 65 },
{ value: "name", caption: "Task Name", width: 200 },
{ value: "duration", caption: "Duration", width: 90 },
{ value: "predecessors", caption: "Predecessors", width: 120, visible: false }
]);
view.fetch().then(function () {
ganttSheet.bindGanttView(view);
}).then(function () {
let taskRule = ganttSheet.project.taskStyleRules.getRule("task");
let taskStyle = taskRule.style.taskbarStyle;
taskStyle.middleColor = "#abd08f";
taskRule.style.taskbarStyle = taskStyle;
let summaryRule = ganttSheet.project.taskStyleRules.getRule("summary");
let summaryStyle = summaryRule.style.taskbarStyle;
summaryStyle.middleColor = "#00b050";
summaryStyle.startShape = "leftBracket";
summaryStyle.startColor = "#578335";
summaryStyle.endShape = "rightBracket";
summaryStyle.endColor = "#578335";
summaryRule.style.taskbarStyle = summaryStyle;
});
};
function syncConfigFromStyle() {
var styleRuleName = ruleName.value;
var targetStyle = ganttSheet.project.taskStyleRules.getRule(styleRuleName).style.taskbarStyle;
if (targetStyle) {
startShape.value = targetStyle.startShape;
startType.value = targetStyle.startType;
startColor.value = targetStyle.startColor ? targetStyle.startColor : "";
middleShape.value = targetStyle.middleShape;
middlePattern.value = targetStyle.middlePattern;
middleColor.value = targetStyle.middleColor ? targetStyle.middleColor : "";
endShape.value = targetStyle.endShape;
endType.value = targetStyle.endType;
endColor.value = targetStyle.endColor ? targetStyle.endColor : "";
leftText.value = targetStyle.leftText || "";
rightText.value = targetStyle.rightText || "";
topText.value = targetStyle.topText || "";
bottomText.value = targetStyle.bottomText || "";
insideText.value = targetStyle.insideText || "";
}
};
function getStyleFromConfig(targetStyle) {
if (!targetStyle) {
targetStyle = {};
}
targetStyle.startShape = startShape.value;
targetStyle.startType = startType.value;
targetStyle.startColor = startColor.value;
targetStyle.middleShape = middleShape.value;
targetStyle.middlePattern = middlePattern.value;
targetStyle.middleColor = middleColor.value;
targetStyle.endShape = endShape.value;
targetStyle.endType = endType.value;
targetStyle.endColor = endColor.value;
targetStyle.leftText = leftText.value;
targetStyle.rightText = rightText.value;
targetStyle.topText = topText.value;
targetStyle.bottomText = bottomText.value;
targetStyle.insideText = insideText.value;
return targetStyle;
};
function setStyle() {
ganttSheet.suspendPaint();
var styleRuleName = ruleName.value;
var targetStyleRule = ganttSheet.project.taskStyleRules.getRule(styleRuleName);
let ruleType = ["task", "milestone", "summary", "projectSummary", "manualTask", "manualMilestone", "durationOnly", "manualSummary", "startOnly", "finishOnly", "durationOnlyMilestone", "startOnlyMilestone", "finishOnlyMilestone", "progress", "manualProgress"];
let style = targetStyleRule.style;
style.taskbarStyle = getStyleFromConfig(style.taskbarStyle);
ganttSheet.project.taskStyleRules.setItemAt(ruleType.indexOf(styleRuleName), targetStyleRule);
ganttSheet.resumePaint()
}
function initSplitView(spread) {
var host = document.getElementById("split-view");
var content = host.getElementsByClassName("split-content")[0];
var panel = host.getElementsByClassName("split-panel")[0];
new SplitView({
host: host,
content: content,
panel: panel,
refreshContent: function () {
spread.refresh();
}
});
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
box-shadow: inset 0px 0 4px 0 rgba(0, 0, 0, 0.4);
}
.option-block {
background: #fff;
padding: 8px;
margin: 12px 0;
border-radius: 4px;
border: 1px dashed #82bc00;
box-shadow: 0px 0 6px 0 rgba(0, 0, 0, 0.1);
}
.option-block.toggle {
border: 1px dotted #f7a711;
}
.option-row {
font-size: 14px;
box-sizing: border-box;
padding: 4px 0;
}
.option-title {
font-weight: bold;
color: #656565;
}
.option-info {
font-size: 12px;
color: #919191;
margin-top: 6px;
font-weight: normal;
}
.option-info.valid {
color: #82bc00;
}
.option-info.toggle {
color: #f7a711;
}
.option-button {
width: 100%;
padding: 0;
line-height: 20px;
background: #82bc00;
color: #fff;
transition: 0.3s;
cursor: pointer;
outline: none;
border-radius: 4px;
box-sizing: border-box;
box-shadow: 0 1px 4px 0 rgba(0, 0, 0, 0.3);
border: none;
}
.option-button:hover {
background: #82bc00;
color: #fff;
box-shadow: 0 3px 8px 0 rgba(0, 0, 0, 0.4);
}
.option-checkbox {
background: #fff;
border: 1px dashed #f7a711;
color: #f7a711;
padding: 2px 4px;
transition: 0.3s;
box-sizing: border-box;
cursor: pointer;
}
.option-checkbox.active {
color: #fff;
background: #f7a711;
box-shadow: 0 1px 4px 0 rgba(0, 0, 0, 0.3);
border-radius: 4px;
}
.selection-box {
position: relative;
}
.selection-box>select {
text-align: left;
width: 100%;
height: 20px;
padding: 0;
line-height: 20px;
background: transparent;
border: none;
border-bottom: 2px solid #656565;
color: #656565;
transition: 0.3s;
cursor: pointer;
outline: none;
box-sizing: border-box;
}
.selection-box>select>option {
background: white;
}
.selection-box>select:focus {
border-bottom: 2px solid #82bc00;
color: #82bc00;
box-shadow: 0 2px 6px 0 rgba(0, 0, 0, 0.3);
}
.selection-box>label {
position: absolute;
cursor: pointer;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
right: 0;
top: 6px;
box-shadow: 0 1px 4px 0 rgba(0, 0, 0, 0.3);
}
.input-box {
position: relative;
}
.input-box>input[type=text] {
width: 100%;
background: transparent;
border: none;
color: #656565;
border-bottom: 2px solid #656565;
outline: none;
box-sizing: border-box;
transition: 0.3s;
}
.input-box>input[type=text]:focus {
color: #82bc00;
border-bottom: 2px solid #82bc00;
}
.input-box>label {
cursor: pointer;
position: absolute;
right: 0;
top: 5px;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
box-shadow: 0 1px 4px 0 rgba(0, 0, 0, 0.3);
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/spread/source/splitView/splitView.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script src="$DEMOROOT$/spread/source/splitView/SplitView.js"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-ganttsheet': 'npm:@mescius/spread-sheets-ganttsheet/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

Built-in Style Rules
There are several built-in style rules for each taskbar type (GC.Spread.Sheets.GanttSheet.TaskbarStyleRuleName):
durationOnly
durationOnlyMilestone
finishOnly
finishOnlyMilestone
manualMilestone
manualProgress
manualSummary
manualTask
milestone
progress
projectSummary
startOnly
startOnlyMilestone
summary
task
You can get the style rule and change its style properties like so:
Configurable Style Properties
startShape: GC.Spread.Sheets.GanttSheet.TaskbarEndShape
startType: GC.Spread.Sheets.GanttSheet.TaskbarEndType
startColor: string
endShape: GC.Spread.Sheets.GanttSheet.TaskbarEndShape
endType: GC.Spread.Sheets.GanttSheet.TaskbarEndType
endColor: string
middleShape: GC.Spread.Sheets.GanttSheet.TaskbarMiddleShape
middlePattern: GC.Spread.Sheets.GanttSheet.TaskbarFillPattern
middleColor: string
leftText: string
rightText: string
topText: string
bottomText: string
insideText: string
Text properties like leftText support the data field name and column formula:
Custom Style Rules
You can create a custom style rule based on the base style rule class (GC.Spread.Sheets.GanttSheet.TaskbarStyleRule):
Then add your custom style rule to the taskbar style rule collection (GC.Spread.Sheets.GanttSheet.TaskbarStyleRules):
You can update an existing custom style rule:
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-ganttsheet";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
const useState = React.useState;
let ganttSheet = null;
let myTable = null;
export function AppFunc() {
const [state, setState] = useState({
ruleName: "task",
startShape: "",
startType: "",
startColor: "",
middleShape: "rectangleBar",
middlePattern: "diagonalLeft",
middleColor: "#8abbed",
endShape: "",
endType: "",
endColor: "",
leftText: "",
rightText: "",
topText: "",
bottomText: "",
insideText: ""
})
const initSpread = (spread) => {
spread.suspendPaint();
spread.clearSheets();
initDataSource(spread);
initGanttSheet(spread);
spread.resumePaint();
initSplitView(spread);
}
const initDataSource = (spread) => {
var tableName = "Gantt_Id";
var baseApiUrl = getBaseApiUrl();
var apiUrl = baseApiUrl + "/" + tableName;
var dataManager = spread.dataManager();
myTable = dataManager.addTable("myTable", {
batch: true,
remote: {
read: {
url: apiUrl
}
},
schema: {
hierarchy: {
type: "Parent",
column: "parentId"
},
columns: {
id: { isPrimaryKey: true },
taskNumber: { dataType: "rowOrder" }
}
}
});
}
const initGanttSheet = (spread) => {
ganttSheet = spread.addSheetTab(0, "GanttSheet", GC.Spread.Sheets.SheetType.ganttSheet);
var view = myTable.addView("ganttView", [
{ value: "taskNumber", caption: "NO.", width: 60 },
{ value: "mode", caption: "Mode", width: 65 },
{ value: "name", caption: "Task Name", width: 200 },
{ value: "duration", caption: "Duration", width: 90 },
{ value: "predecessors", caption: "Predecessors", width: 120, visible: false }
]);
view.fetch().then(function () {
ganttSheet.bindGanttView(view);
}).then(function () {
let taskRule = ganttSheet.project.taskStyleRules.getRule("task");
let taskStyle = taskRule.style.taskbarStyle;
taskStyle.middleColor = "#abd08f";
taskRule.style.taskbarStyle = taskStyle;
let summaryRule = ganttSheet.project.taskStyleRules.getRule("summary");
let summaryStyle = summaryRule.style.taskbarStyle;
summaryStyle.middleColor = "#00b050";
summaryStyle.startShape = "leftBracket";
summaryStyle.startColor = "#578335";
summaryStyle.endShape = "rightBracket";
summaryStyle.endColor = "#578335";
summaryRule.style.taskbarStyle = summaryStyle;
});
}
const syncConfigFromStyle = (ruleName) => {
setState((state) => ({ ...state, ruleName: ruleName }));
var styleRuleName = ruleName;
var targetStyle = ganttSheet.project.taskStyleRules.getRule(styleRuleName).style.taskbarStyle;
if (targetStyle) {
setState((state) => ({ ...state, startShape: targetStyle.startShape }));
setState((state) => ({ ...state, startType: targetStyle.startType }));
setState((state) => ({ ...state, startColor: targetStyle.startColor ? targetStyle.startColor : "" }));
setState((state) => ({ ...state, middleShape: targetStyle.middleShape }));
setState((state) => ({ ...state, middlePattern: targetStyle.middlePattern }));
setState((state) => ({ ...state, middleColor: targetStyle.middleColor ? targetStyle.middleColor : "" }));
setState((state) => ({ ...state, endShape: targetStyle.endShape }));
setState((state) => ({ ...state, endType: targetStyle.endType }));
setState((state) => ({ ...state, endColor: targetStyle.endColor ? targetStyle.endColor : "" }));
setState((state) => ({ ...state, leftText: targetStyle.leftText || "" }));
setState((state) => ({ ...state, rightText: targetStyle.rightText || "" }));
setState((state) => ({ ...state, topText: targetStyle.topText || "" }));
setState((state) => ({ ...state, bottomText: targetStyle.bottomText || "" }));
setState((state) => ({ ...state, insideText: targetStyle.insideText || "" }));
}
}
const getStyleFromConfig = (targetStyle) => {
if (!targetStyle) {
targetStyle = {};
}
targetStyle.startShape = state.startShape;
targetStyle.startType = state.startType;
targetStyle.startColor = state.startColor;
targetStyle.middleShape = state.middleShape;
targetStyle.middlePattern = state.middlePattern;
targetStyle.middleColor = state.middleColor;
targetStyle.endShape = state.endShape;
targetStyle.endType = state.endType;
targetStyle.endColor = state.endColor;
targetStyle.leftText = state.leftText;
targetStyle.rightText = state.rightText;
targetStyle.topText = state.topText;
targetStyle.bottomText = state.bottomText;
targetStyle.insideText = state.insideText;
return targetStyle;
}
const setStyle = () => {
ganttSheet.suspendPaint();
var styleRuleName = state.ruleName;
var targetStyleRule = ganttSheet.project.taskStyleRules.getRule(styleRuleName);
let ruleType = ["task", "milestone", "summary", "projectSummary", "manualTask", "manualMilestone", "durationOnly", "manualSummary", "startOnly", "finishOnly", "durationOnlyMilestone", "startOnlyMilestone", "finishOnlyMilestone", "progress", "manualProgress"];
let style = targetStyleRule.style;
style.taskbarStyle = getStyleFromConfig(style.taskbarStyle);
ganttSheet.project.taskStyleRules.setItemAt(ruleType.indexOf(styleRuleName), targetStyleRule);
ganttSheet.resumePaint()
}
return (
<div id="split-view" class="sample-tutorial">
<div class="sample-spreadsheets split-content">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}></SpreadSheets>
</div>
<div class="options-container split-panel">
<div class="option-row option-title">
Config the taskbar style rules.
</div>
<div class="option-block">
<div class="option-row selection-box">
<label for="rule-name">Rule Name</label>
<select id="rule-name" defaultValue="task" onChange={(e) => { syncConfigFromStyle(e.target.value) }}>
<option value="durationOnly">durationOnly</option>
<option value="durationOnlyMilestone">durationOnlyMilestone</option>
<option value="finishOnly">finishOnly</option>
<option value="finishOnlyMilestone">finishOnlyMilestone</option>
<option value="manualMilestone">manualMilestone</option>
<option value="manualProgress">manualProgress</option>
<option value="manualSummary">manualSummary</option>
<option value="manualTask">manualTask</option>
<option value="milestone">milestone</option>
<option value="progress">progress</option>
<option value="projectSummary">projectSummary</option>
<option value="startOnly">startOnly</option>
<option value="startOnlyMilestone">startOnlyMilestone</option>
<option value="summary">summary</option>
<option value="task" selected>task</option>
</select>
</div>
<div class="option-row">
<input type="button" id="set-style" class="option-button" value="Set Taskbar Styles" onClick={() => { setStyle() }} />
</div>
</div>
<div class="option-block">
<div class="option-row option-title">
Config the taskbar style.
</div>
<div class="option-block">
<div class="option-row option-title">
Start
</div>
<div class="option-row selection-box">
<label for="start-shape">Shape</label>
<select id="start-shape" defaultValue="lineShape" value={state.startShape} onChange={(e) => { setState({ ...state, startShape: e.target.value }) }}>
<option value=""></option>
<option value="arrowDown">arrowDown</option>
<option value="arrowUp">arrowUp</option>
<option value="caretDownTop">caretDownTop</option>
<option value="caretUpBottom">caretUpBottom</option>
<option value="circle">circle</option>
<option value="circleArrowDown">circleArrowDown</option>
<option value="circleArrowUp">circleArrowUp</option>
<option value="circleDiamond">circleDiamond</option>
<option value="circleTriangleDown">circleTriangleDown</option>
<option value="circleTriangleUp">circleTriangleUp</option>
<option value="diamond">diamond</option>
<option value="houseDown">houseDown</option>
<option value="houseUp">houseUp</option>
<option value="leftBracket">leftBracket</option>
<option value="leftFade">leftFade</option>
<option value="lineShape" selected>lineShape</option>
<option value="rightBracket">rightBracket</option>
<option value="rightFade">rightFade</option>
<option value="square">square</option>
<option value="star">star</option>
<option value="triangleDown">triangleDown</option>
<option value="triangleLeft">triangleLeft</option>
<option value="triangleRight">triangleRight</option>
<option value="triangleUp">triangleUp</option>
</select>
</div>
<div class="option-row selection-box">
<label for="start-type">Type</label>
<select id="start-type" defaultValue="solid" value={state.startType} onChange={(e) => { setState({ ...state, startType: e.target.value }) }}>
<option value=""></option>
<option value="solid" selected>solid</option>
<option value="dashed">dashed</option>
<option value="framed">framed</option>
</select>
</div>
<div class="option-row input-box">
<label for="start-color">Color</label>
<input type="text" id="start-color" defaultValue="" value={state.startColor} onChange={(e) => { setState({ ...state, startColor: e.target.value }) }} />
<div class="option-info valid">* valid value: color string</div>
</div>
</div>
<div class="option-block">
<div class="option-row option-title">
Middle
</div>
<div class="option-row selection-box">
<label for="middle-shape">Shape</label>
<select id="middle-shape" defaultValue="rectangleBar" value={state.middleShape} onChange={(e) => { setState({ ...state, middleShape: e.target.value }) }}>
<option value=""></option>
<option value="lineBottom">lineBottom</option>
<option value="lineMiddle">lineMiddle</option>
<option value="lineTop">lineTop</option>
<option value="rectangleBar" selected>rectangleBar</option>
<option value="rectangleBottom">rectangleBottom</option>
<option value="rectangleMiddle">rectangleMiddle</option>
<option value="rectangleTop">rectangleTop</option>
</select>
</div>
<div class="option-row selection-box">
<label for="middle-pattern">Fill Pattern</label>
<select id="middle-pattern" defaultValue="diagonalLeft" value={state.middlePattern} onChange={(e) => { setState({ ...state, middlePattern: e.target.value }) }}>
<option value=""></option>
<option value="darkFill">darkFill</option>
<option value="dashedBorder">dashedBorder</option>
<option value="diagonalCross">diagonalCross</option>
<option value="diagonalLeft" selected>diagonalLeft</option>
<option value="diagonalRight">diagonalRight</option>
<option value="hollow">hollow</option>
<option value="lightFill">lightFill</option>
<option value="lineCross">lineCross</option>
<option value="lineHorizontal">lineHorizontal</option>
<option value="lineVertical">lineVertical</option>
<option value="mediumFill">mediumFill</option>
<option value="solidFill">solidFill</option>
</select>
</div>
<div class="option-row input-box">
<label for="middle-color">Color</label>
<input type="text" id="middle-color" defaultValue="" value={state.middleColor} onChange={(e) => { setState({ ...state, middleColor: e.target.value }) }} />
<div class="option-info valid">* valid value: color string</div>
</div>
</div>
<div class="option-block">
<div class="option-row option-title">
End
</div>
<div class="option-row selection-box">
<label for="end-shape">Shape</label>
<select id="end-shape" defaultValue="lineShape" value={state.endShape} onChange={(e) => { setState({ ...state, endShape: e.target.value }) }}>
<option value=""></option>
<option value="arrowDown">arrowDown</option>
<option value="arrowUp">arrowUp</option>
<option value="caretDownTop">caretDownTop</option>
<option value="caretUpBottom">caretUpBottom</option>
<option value="circle">circle</option>
<option value="circleArrowDown">circleArrowDown</option>
<option value="circleArrowUp">circleArrowUp</option>
<option value="circleDiamond">circleDiamond</option>
<option value="circleTriangleDown">circleTriangleDown</option>
<option value="circleTriangleUp">circleTriangleUp</option>
<option value="diamond">diamond</option>
<option value="houseDown">houseDown</option>
<option value="houseUp">houseUp</option>
<option value="leftBracket">leftBracket</option>
<option value="leftFade">leftFade</option>
<option value="lineShape" selected>lineShape</option>
<option value="rightBracket">rightBracket</option>
<option value="rightFade">rightFade</option>
<option value="square">square</option>
<option value="star">star</option>
<option value="triangleDown">triangleDown</option>
<option value="triangleLeft">triangleLeft</option>
<option value="triangleRight">triangleRight</option>
<option value="triangleUp">triangleUp</option>
</select>
</div>
<div class="option-row selection-box">
<label for="end-type">Type</label>
<select id="end-type" defaultValue="solid" value={state.endType} onChange={(e) => { setState({ ...state, endType: e.target.value }) }}>
<option value=""></option>
<option value="solid" selected>solid</option>
<option value="dashed">dashed</option>
<option value="framed">framed</option>
</select>
</div>
<div class="option-row input-box">
<label for="end-color">Color</label>
<input type="text" id="end-color" defaultValue="" value={state.endColor} onChange={(e) => { setState({ ...state, endColor: e.target.value }) }} />
<div class="option-info valid">* valid value: color string</div>
</div>
</div>
</div>
<div class="option-block">
<div class="option-row option-title">
Config the taskbar text.
</div>
<div class="option-row input-box">
<label for="left-text">Left Text</label>
<input type="text" id="left-text" defaultValue="" value={state.leftText} onChange={(e) => { setState({ ...state, leftText: e.target.value }) }} />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
<div class="option-row input-box">
<label for="right-text">Right Text</label>
<input type="text" id="right-text" defaultValue="" value={state.rightText} onChange={(e) => { setState({ ...state, rightText: e.target.value }) }} />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
<div class="option-row input-box">
<label for="top-text">Top Text</label>
<input type="text" id="top-text" defaultValue="" value={state.topText} onChange={(e) => { setState({ ...state, topText: e.target.value }) }} />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
<div class="option-row input-box">
<label for="bottom-text">Bottom Text</label>
<input type="text" id="bottom-text" defaultValue="" value={state.bottomText} onChange={(e) => { setState({ ...state, bottomText: e.target.value }) }} />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
<div class="option-row input-box">
<label for="inside-text">Inside Text</label>
<input type="text" id="inside-text" defaultValue="" value={state.insideText} onChange={(e) => { setState({ ...state, insideText: e.target.value }) }} />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
</div>
</div>
</div>
);
}
function initSplitView(spread) {
var host = document.getElementById("split-view");
var content = host.getElementsByClassName("split-content")[0];
var panel = host.getElementsByClassName("split-panel")[0];
new SplitView({
host: host,
content: content,
panel: panel,
refreshContent: function () {
spread.refresh();
}
});
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-ganttsheet";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.ganttSheet = null;
this.state = {
ruleName: "task",
startShape: "",
startType: "",
startColor: "",
middleShape: "rectangleBar",
middlePattern: "diagonalLeft",
middleColor: "#8abbed",
endShape: "",
endType: "",
endColor: "",
leftText: "",
rightText: "",
topText: "",
bottomText: "",
insideText: ""
};
}
render() {
return (
<div id="split-view" class="sample-tutorial">
<div class="sample-spreadsheets split-content">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}></SpreadSheets>
</div>
<div class="options-container split-panel">
<div class="option-row option-title">
Config the taskbar style rules.
</div>
<div class="option-block">
<div class="option-row selection-box">
<label for="rule-name">Rule Name</label>
<select id="rule-name" defaultValue="task" onChange={ (e) => { this.syncConfigFromStyle(e.target.value) } }>
<option value="durationOnly">durationOnly</option>
<option value="durationOnlyMilestone">durationOnlyMilestone</option>
<option value="finishOnly">finishOnly</option>
<option value="finishOnlyMilestone">finishOnlyMilestone</option>
<option value="manualMilestone">manualMilestone</option>
<option value="manualProgress">manualProgress</option>
<option value="manualSummary">manualSummary</option>
<option value="manualTask">manualTask</option>
<option value="milestone">milestone</option>
<option value="progress">progress</option>
<option value="projectSummary">projectSummary</option>
<option value="startOnly">startOnly</option>
<option value="startOnlyMilestone">startOnlyMilestone</option>
<option value="summary">summary</option>
<option value="task" selected>task</option>
</select>
</div>
<div class="option-row">
<input type="button" id="set-style" class="option-button" value="Set Taskbar Styles" onClick={ () => { this.setStyle() } } />
</div>
</div>
<div class="option-block">
<div class="option-row option-title">
Config the taskbar style.
</div>
<div class="option-block">
<div class="option-row option-title">
Start
</div>
<div class="option-row selection-box">
<label for="start-shape">Shape</label>
<select id="start-shape" defaultValue="lineShape" value={ this.state.startShape } onChange={ (e) => { this.setState({ startShape: e.target.value }) } }>
<option value=""></option>
<option value="arrowDown">arrowDown</option>
<option value="arrowUp">arrowUp</option>
<option value="caretDownTop">caretDownTop</option>
<option value="caretUpBottom">caretUpBottom</option>
<option value="circle">circle</option>
<option value="circleArrowDown">circleArrowDown</option>
<option value="circleArrowUp">circleArrowUp</option>
<option value="circleDiamond">circleDiamond</option>
<option value="circleTriangleDown">circleTriangleDown</option>
<option value="circleTriangleUp">circleTriangleUp</option>
<option value="diamond">diamond</option>
<option value="houseDown">houseDown</option>
<option value="houseUp">houseUp</option>
<option value="leftBracket">leftBracket</option>
<option value="leftFade">leftFade</option>
<option value="lineShape" selected>lineShape</option>
<option value="rightBracket">rightBracket</option>
<option value="rightFade">rightFade</option>
<option value="square">square</option>
<option value="star">star</option>
<option value="triangleDown">triangleDown</option>
<option value="triangleLeft">triangleLeft</option>
<option value="triangleRight">triangleRight</option>
<option value="triangleUp">triangleUp</option>
</select>
</div>
<div class="option-row selection-box">
<label for="start-type">Type</label>
<select id="start-type" defaultValue="solid" value={ this.state.startType } onChange={ (e) => { this.setState({ startType: e.target.value }) } }>
<option value=""></option>
<option value="solid" selected>solid</option>
<option value="dashed">dashed</option>
<option value="framed">framed</option>
</select>
</div>
<div class="option-row input-box">
<label for="start-color">Color</label>
<input type="text" id="start-color" defaultValue="" value={ this.state.startColor } onChange={ (e) => { this.setState({ startColor: e.target.value }) } } />
<div class="option-info valid">* valid value: color string</div>
</div>
</div>
<div class="option-block">
<div class="option-row option-title">
Middle
</div>
<div class="option-row selection-box">
<label for="middle-shape">Shape</label>
<select id="middle-shape" defaultValue="rectangleBar" value={ this.state.middleShape } onChange={ (e) => { this.setState({ middleShape: e.target.value }) } }>
<option value=""></option>
<option value="lineBottom">lineBottom</option>
<option value="lineMiddle">lineMiddle</option>
<option value="lineTop">lineTop</option>
<option value="rectangleBar" selected>rectangleBar</option>
<option value="rectangleBottom">rectangleBottom</option>
<option value="rectangleMiddle">rectangleMiddle</option>
<option value="rectangleTop">rectangleTop</option>
</select>
</div>
<div class="option-row selection-box">
<label for="middle-pattern">Fill Pattern</label>
<select id="middle-pattern" defaultValue="diagonalLeft" value={ this.state.middlePattern } onChange={ (e) => { this.setState({ middlePattern: e.target.value }) } }>
<option value=""></option>
<option value="darkFill">darkFill</option>
<option value="dashedBorder">dashedBorder</option>
<option value="diagonalCross">diagonalCross</option>
<option value="diagonalLeft" selected>diagonalLeft</option>
<option value="diagonalRight">diagonalRight</option>
<option value="hollow">hollow</option>
<option value="lightFill">lightFill</option>
<option value="lineCross">lineCross</option>
<option value="lineHorizontal">lineHorizontal</option>
<option value="lineVertical">lineVertical</option>
<option value="mediumFill">mediumFill</option>
<option value="solidFill">solidFill</option>
</select>
</div>
<div class="option-row input-box">
<label for="middle-color">Color</label>
<input type="text" id="middle-color" defaultValue="" value={ this.state.middleColor } onChange={ (e) => { this.setState({ middleColor: e.target.value }) } } />
<div class="option-info valid">* valid value: color string</div>
</div>
</div>
<div class="option-block">
<div class="option-row option-title">
End
</div>
<div class="option-row selection-box">
<label for="end-shape">Shape</label>
<select id="end-shape" defaultValue="lineShape" value={ this.state.endShape } onChange={ (e) => { this.setState({ endShape: e.target.value }) } }>
<option value=""></option>
<option value="arrowDown">arrowDown</option>
<option value="arrowUp">arrowUp</option>
<option value="caretDownTop">caretDownTop</option>
<option value="caretUpBottom">caretUpBottom</option>
<option value="circle">circle</option>
<option value="circleArrowDown">circleArrowDown</option>
<option value="circleArrowUp">circleArrowUp</option>
<option value="circleDiamond">circleDiamond</option>
<option value="circleTriangleDown">circleTriangleDown</option>
<option value="circleTriangleUp">circleTriangleUp</option>
<option value="diamond">diamond</option>
<option value="houseDown">houseDown</option>
<option value="houseUp">houseUp</option>
<option value="leftBracket">leftBracket</option>
<option value="leftFade">leftFade</option>
<option value="lineShape" selected>lineShape</option>
<option value="rightBracket">rightBracket</option>
<option value="rightFade">rightFade</option>
<option value="square">square</option>
<option value="star">star</option>
<option value="triangleDown">triangleDown</option>
<option value="triangleLeft">triangleLeft</option>
<option value="triangleRight">triangleRight</option>
<option value="triangleUp">triangleUp</option>
</select>
</div>
<div class="option-row selection-box">
<label for="end-type">Type</label>
<select id="end-type" defaultValue="solid" value={ this.state.endType } onChange={ (e) => { this.setState({ endType: e.target.value }) } }>
<option value=""></option>
<option value="solid" selected>solid</option>
<option value="dashed">dashed</option>
<option value="framed">framed</option>
</select>
</div>
<div class="option-row input-box">
<label for="end-color">Color</label>
<input type="text" id="end-color" defaultValue="" value={ this.state.endColor } onChange={ (e) => { this.setState({ endColor: e.target.value }) } } />
<div class="option-info valid">* valid value: color string</div>
</div>
</div>
</div>
<div class="option-block">
<div class="option-row option-title">
Config the taskbar text.
</div>
<div class="option-row input-box">
<label for="left-text">Left Text</label>
<input type="text" id="left-text" defaultValue="" value={ this.state.leftText } onChange={ (e) => { this.setState({ leftText: e.target.value }) } } />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
<div class="option-row input-box">
<label for="right-text">Right Text</label>
<input type="text" id="right-text" defaultValue="" value={ this.state.rightText } onChange={ (e) => { this.setState({ rightText: e.target.value }) } } />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
<div class="option-row input-box">
<label for="top-text">Top Text</label>
<input type="text" id="top-text" defaultValue="" value={ this.state.topText } onChange={ (e) => { this.setState({ topText: e.target.value }) } } />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
<div class="option-row input-box">
<label for="bottom-text">Bottom Text</label>
<input type="text" id="bottom-text" defaultValue="" value={ this.state.bottomText } onChange={ (e) => { this.setState({ bottomText: e.target.value }) } } />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
<div class="option-row input-box">
<label for="inside-text">Inside Text</label>
<input type="text" id="inside-text" defaultValue="" value={ this.state.insideText } onChange={ (e) => { this.setState({ insideText: e.target.value }) } } />
<div class="option-info valid">* valid value: field string or column formula</div>
</div>
</div>
</div>
</div>
);
}
initSpread(spread) {
spread.suspendPaint();
spread.clearSheets();
this.initDataSource(spread);
this.initGanttSheet(spread);
spread.resumePaint();
initSplitView(spread);
}
initDataSource(spread) {
var tableName = "Gantt_Id";
var baseApiUrl = getBaseApiUrl();
var apiUrl = baseApiUrl + "/" + tableName;
var dataManager = spread.dataManager();
var myTable = dataManager.addTable("myTable", {
batch: true,
remote: {
read: {
url: apiUrl
}
},
schema: {
hierarchy: {
type: "Parent",
column: "parentId"
},
columns: {
id: { isPrimaryKey: true },
taskNumber: { dataType: "rowOrder" }
}
}
});
this.myTable = myTable;
}
initGanttSheet(spread) {
var ganttSheet = spread.addSheetTab(0, "GanttSheet", GC.Spread.Sheets.SheetType.ganttSheet);
var view = this.myTable.addView("ganttView", [
{ value: "taskNumber", caption: "NO.", width: 60 },
{ value: "mode", caption: "Mode", width: 65 },
{ value: "name", caption: "Task Name", width: 200 },
{ value: "duration", caption: "Duration", width: 90 },
{ value: "predecessors", caption: "Predecessors", width: 120, visible: false }
]);
view.fetch().then(function() {
ganttSheet.bindGanttView(view);
}).then(function() {
let taskRule = ganttSheet.project.taskStyleRules.getRule("task");
let taskStyle = taskRule.style.taskbarStyle;
taskStyle.middleColor = "#abd08f";
taskRule.style.taskbarStyle = taskStyle;
let summaryRule = ganttSheet.project.taskStyleRules.getRule("summary");
let summaryStyle = summaryRule.style.taskbarStyle;
summaryStyle.middleColor = "#00b050";
summaryStyle.startShape = "leftBracket";
summaryStyle.startColor = "#578335";
summaryStyle.endShape = "rightBracket";
summaryStyle.endColor = "#578335";
summaryRule.style.taskbarStyle = summaryStyle;
});
this.ganttSheet = ganttSheet;
}
syncConfigFromStyle(ruleName) {
this.setState({ ruleName: ruleName });
var ganttSheet = this.ganttSheet;
var styleRuleName = ruleName;
var targetStyle = ganttSheet.project.taskStyleRules.getRule(styleRuleName).style.taskbarStyle;
if (targetStyle) {
this.setState({ startShape: targetStyle.startShape });
this.setState({ startType: targetStyle.startType });
this.setState({ startColor: targetStyle.startColor ? targetStyle.startColor : "" });
this.setState({ middleShape: targetStyle.middleShape });
this.setState({ middlePattern: targetStyle.middlePattern });
this.setState({ middleColor: targetStyle.middleColor ? targetStyle.middleColor : "" });
this.setState({ endShape: targetStyle.endShape });
this.setState({ endType: targetStyle.endType });
this.setState({ endColor: targetStyle.endColor ? targetStyle.endColor : "" });
this.setState({ leftText: targetStyle.leftText || "" });
this.setState({ rightText: targetStyle.rightText || "" });
this.setState({ topText: targetStyle.topText || "" });
this.setState({ bottomText: targetStyle.bottomText || "" });
this.setState({ insideText: targetStyle.insideText || "" });
}
}
getStyleFromConfig(targetStyle) {
if (!targetStyle) {
targetStyle = {};
}
targetStyle.startShape = this.state.startShape;
targetStyle.startType = this.state.startType;
targetStyle.startColor = this.state.startColor;
targetStyle.middleShape = this.state.middleShape;
targetStyle.middlePattern = this.state.middlePattern;
targetStyle.middleColor = this.state.middleColor;
targetStyle.endShape = this.state.endShape;
targetStyle.endType = this.state.endType;
targetStyle.endColor = this.state.endColor;
targetStyle.leftText = this.state.leftText;
targetStyle.rightText = this.state.rightText;
targetStyle.topText = this.state.topText;
targetStyle.bottomText = this.state.bottomText;
targetStyle.insideText = this.state.insideText;
return targetStyle;
}
setStyle() {
var ganttSheet = this.ganttSheet;
ganttSheet.suspendPaint();
var styleRuleName = this.state.ruleName;
var targetStyleRule = ganttSheet.project.taskStyleRules.getRule(styleRuleName);
let ruleType = ["task", "milestone", "summary", "projectSummary", "manualTask", "manualMilestone", "durationOnly", "manualSummary", "startOnly", "finishOnly", "durationOnlyMilestone", "startOnlyMilestone", "finishOnlyMilestone", "progress", "manualProgress"];
let style = targetStyleRule.style;
style.taskbarStyle = this.getStyleFromConfig(style.taskbarStyle);
ganttSheet.project.taskStyleRules.setItemAt(ruleType.indexOf(styleRuleName), targetStyleRule);
ganttSheet.resumePaint()
}
}
function initSplitView(spread) {
var host = document.getElementById("split-view");
var content = host.getElementsByClassName("split-content")[0];
var panel = host.getElementsByClassName("split-panel")[0];
new SplitView({
host: host,
content: content,
panel: panel,
refreshContent: function() {
spread.refresh();
}
});
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/spread/source/splitView/splitView.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<!-- plugins -->
<script src="$DEMOROOT$/spread/source/splitView/SplitView.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
box-shadow: inset 0px 0 4px 0 rgba(0,0,0,0.4);
}
.option-block {
background: #fff;
padding: 8px;
margin: 12px 0;
border-radius: 4px;
border: 1px dashed #82bc00;
box-shadow: 0px 0 6px 0 rgba(0,0,0,0.1);
}
.option-block.toggle {
border: 1px dotted #f7a711;
}
.option-row {
font-size: 14px;
box-sizing: border-box;
padding: 4px 0;
}
.option-title {
font-weight: bold;
color: #656565;
}
.option-info {
font-size: 12px;
color: #919191;
margin-top: 6px;
font-weight: normal;
}
.option-info.valid {
color: #82bc00;
}
.option-info.toggle {
color: #f7a711;
}
.option-button {
width: 100%;
padding: 0;
line-height: 20px;
background: #82bc00;
color: #fff;
transition: 0.3s;
cursor: pointer;
outline: none;
border-radius: 4px;
box-sizing: border-box;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
border: none;
}
.option-button:hover {
background: #82bc00;
color: #fff;
box-shadow: 0 3px 8px 0 rgba(0,0,0,0.4);
}
.option-checkbox {
background: #fff;
border: 1px dashed #f7a711;
color: #f7a711;
padding: 2px 4px;
transition: 0.3s;
box-sizing: border-box;
cursor: pointer;
}
.option-checkbox.active {
color: #fff;
background: #f7a711;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
border-radius: 4px;
}
.selection-box {
position: relative;
}
.selection-box > select {
text-align: left;
width: 100%;
height: 20px;
padding: 0;
line-height: 20px;
background: transparent;
border: none;
border-bottom: 2px solid #656565;
color: #656565;
transition: 0.3s;
cursor: pointer;
outline: none;
box-sizing: border-box;
}
.selection-box > select > option {
background: white;
}
.selection-box > select:focus {
border-bottom: 2px solid #82bc00;
color: #82bc00;
box-shadow: 0 2px 6px 0 rgba(0,0,0,0.3);
}
.selection-box > label {
position: absolute;
cursor: pointer;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
right: 0;
top: 6px;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
}
.input-box {
position: relative;
}
.input-box > input[type=text] {
width: 100%;
background: transparent;
border: none;
color: #656565;
border-bottom: 2px solid #656565;
outline: none;
box-sizing: border-box;
transition: 0.3s;
}
.input-box > input[type=text]:focus {
color: #82bc00;
border-bottom: 2px solid #82bc00;
}
.input-box > label {
cursor: pointer;
position: absolute;
right: 0;
top: 5px;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-ganttsheet': 'npm:@mescius/spread-sheets-ganttsheet/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);